From 6c59a6c48cca8d869a8909eb25b6224cbd4ac877 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Thu, 12 Feb 2026 17:58:54 +0100
Subject: [PATCH] WIP zoneinfo and zic upgrade

---
 lib/libc/stdtime/private.h  |   11 +
 share/zoneinfo/NEWS         | 1056 +++++++++++++++++++++++-
 share/zoneinfo/README       |   27 +-
 share/zoneinfo/africa       |  415 ++++------
 share/zoneinfo/antarctica   |   99 ++-
 share/zoneinfo/asia         | 1248 ++++++++++++++++++-----------
 share/zoneinfo/australasia  |  458 +++++------
 share/zoneinfo/backward     |  309 +++++--
 share/zoneinfo/etcetera     |   81 +-
 share/zoneinfo/europe       | 1508 ++++++++++++++++-------------------
 share/zoneinfo/iso3166.tab  |   23 +-
 share/zoneinfo/leapseconds  |   28 +-
 share/zoneinfo/northamerica |  679 ++++++++--------
 share/zoneinfo/southamerica |  691 +++++++++-------
 share/zoneinfo/zone.tab     |   90 +--
 usr.sbin/zic/zic.c          | 1053 ++++++++++++++----------
 16 files changed, 4699 insertions(+), 3077 deletions(-)

diff --git a/lib/libc/stdtime/private.h b/lib/libc/stdtime/private.h
index fe658484e9..b731d06775 100644
--- a/lib/libc/stdtime/private.h
+++ b/lib/libc/stdtime/private.h
@@ -90,6 +90,17 @@ const char *	scheck(const char * string, const char * format);
 #define TYPE_SIGNED(type) (((type) -1) < 0)
 #endif /* !defined TYPE_SIGNED */
 
+#define	TWOS_COMPLEMENT(t) ((t) ~ (t) 0 < 0)
+
+/* Max and min values of the integer type T, of which only the bottom
+   B bits are used, and where the highest-order used bit is considered
+   to be a sign bit if T is signed.  */
+#define	MAXVAL(t, b)						\
+  ((t) (((t) 1 << ((b) - 1 - TYPE_SIGNED(t)))			\
+	- 1 + ((t) 1 << ((b) - 1 - TYPE_SIGNED(t)))))
+#define	MINVAL(t, b)						\
+  ((t) (TYPE_SIGNED(t) ? - TWOS_COMPLEMENT(t) - MAXVAL(t, b) : 0))
+
 /* The minimum and maximum finite time values.  */
 static time_t const time_t_min =
   (TYPE_SIGNED(time_t)
